classdef SCDclass_wrapper < SCDclass_component
  % Wrapper class containing algos
  methods
    function obj = SCDclass_wrapper(name)
      obj.name    = name;
      obj.algos   = [];
      obj.ddname  = [name,'.sldd'];
      obj.mdlname = [name,'.slx'];
      
      assert(~isempty(which(obj.mdlname)),...
        'could not find %s for SCD component %s',obj.mdlname,obj.name);
    end
    
    function updatetemplatetp(obj)
      % update node algos tunable parameters
      for ii=1:numel(obj.algos)
        if isempty(obj.algos(ii)), continue; end
        obj.algos(ii).updatetemplatetp;
      end
    end
    
    function printinfo(obj)
      fprintf('%s\n',obj.name);
      fprintf('   Algos:');
      if isempty(obj.algos), fprintf('  none'); end
      fprintf('\n');
      for ii=1:numel(obj.algos)
        myalgo = obj.algos(ii);
        fprintf('  %9s%s\n','',myalgo.getname);
      end
    end
  end
end